<template>
  <rui-form model="element"
            :errors="errors"
            :loading="loading"
            @submit.prevent="save"
            @cancel="cancel">
    <rui-date-time-picker v-model="inputs.removal_planned_for"
                          :label="$t('js.elements.action_buttons.removal_date')"
                          :time="false"
                          :input-id="`${formId}-removed-at`"
                          :not-before="element.implantedAt"
                          input-name="removed_at" />
  </rui-form>
</template>

<script>
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'
import RuiDateTimePicker from '@experiments-labs/rise_ui/src/components/Inputs/DateTimePicker/DateTimePicker.vue'

import { randomString } from '@experiments-labs/rise_ui/src/lib/String.js'
import Element from '../../../../classes/models/Element'
import { beginningOfDay } from '@experiments-labs/rise_ui/src/lib/Dates'

export default {
  name: 'GpaElementRemovalForm',
  emits: [
    'cancel',
    'saved',
  ],
  components: { RuiForm, RuiDateTimePicker },
  props: {
    element: { required: true, type: Element },
  },
  data () {
    const today = beginningOfDay(new Date())

    return {
      errors: null,
      loading: false,
      inputs: {
        removal_planned_for: this.$props.element.removalPlannedFor || today,
      },
      formId: randomString(),
    }
  },
  methods: {
    save () {
      this.errors = null
      this.loading = true
      const payload = {
        id: this.$props.element.id,
        date: this.inputs.removal_planned_for,
      }
      return this.$store.dispatch('removeElement', payload)
        .then(() => { this.$emit('saved') })
        .catch((error) => {
          this.errors = error
        })
        .then(() => {
          this.loading = false
        })
    },
    cancel () { this.$emit('cancel') },
  },
}
</script>
